// IP Widget 
//Copyright (C) 2006 Max Maahn
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

var url = "http://checkip.dyndns.org/";
var url2nd = "http://www.whatismyip.com/automation/n09230945.asp";
var interfaceNo = 0;
  
var busy = false;
var waiting = false;
var error = false;
var protocolKey = widget.identifier + "-protocol";
var interfaceKey = widget.identifier + "-interface";
var enKey = new Array(10)
for (var i = 0; i < enKey.length; i++)
{
		enKey[i] = widget.identifier + "-en" + i;
//    widget.setPreferenceForKey (null, airportKey);
//    widget.setPreferenceForKey (null, timeKey);
}
var time;
var firstRun = true;
//var airport = "no";
var pause = 300000;

if (window.widget)
{
widget.onshow = getIpTime;
widget.onremove = cleanUp;
}

// Prefernces...
function changeInterPref (interPref) {
if(window.widget)
{
    widget.setPreferenceForKey(interPref,interfaceKey);
}
}

function changeProtoPref (protoPref) {
if(window.widget)
{
    widget.setPreferenceForKey(protoPref,protocolKey);
}
}


function loadEnX () {
if (firstRun) {
if (window.widget) {
for (var i = 0; i < enKey.length; i++)  {
    ifconfigString = widget.system("/sbin/ifconfig en" + i, null).outputString;
//    ifconfigString = widget.system("more '/ifconfig" + i+"'", null).outputString;
    if (!ifconfigString) {
        continue;
       
        }
    var selectText = document.createElement("option");
    if (ifconfigString.search(/10baseT/) == -1) {
        selectText.text = "en" + i + " (Airport)";
		widget.setPreferenceForKey("Airport",enKey[i]);
        }
    else {
        selectText.text = "en" + i + " (Ethernet)";
		widget.setPreferenceForKey("Ethernet",enKey[i]);
    }  
    selectText.value = "en" + i;
    document.getElementById("selectinter").add(selectText, null); 
    }
    firstRun = false;
}
}
}

function loadPrefs () {
if(window.widget) {
    loadEnX();
    var protoString = widget.preferenceForKey(protocolKey);
    if (protoString)
    {
        if (protoString == "afp://") {
            var protoIndex = 1;
        }
        else if (protoString == "ftp://") {
            var protoIndex = 2;
        }
        else if (protoString == "http://") {
            var protoIndex = 3;
        }
        else if (protoString == "ssh://") {
            var protoIndex = 4;
        }
        else {
            var protoIndex = 0;
        }
    
        document.getElementById("addprotocol").selectedIndex = protoIndex;
    }

        var interString = widget.preferenceForKey(interfaceKey);
       if (interString) {
       		document.getElementById("selectinter").value = interString;
       	}
        
   // if (interString)
   // {
   //     if (interString == "wan") {
   //         var interIndex = 0;
   //     }
   //     else if (interString == "fw0") {
   //         var interIndex = 1;
   //     }
   //    else {
   //         var interIndex = 2 + parseInt(interString.charAt(2));
   //     }
   // 
   //     document.getElementById("selectinter").selectedIndex = interIndex;
   // }    
}
}

function cleanUp () {
    widget.setPreferenceForKey (null, protocolKey);
    widget.setPreferenceForKey (null, interfaceKey);
for (var i = 0; i < enKey.length; i++) {
		widget.setPreferenceForKey (null, enKey[i]);
		}
}


// copy to clipboard
function copy() {
  if(window.widget && !error) {
    if (!busy) {
       printText("copying...",false);
        var protoText = "";
        if (widget.preferenceForKey(protocolKey)) {
            protoText = widget.preferenceForKey(protocolKey);
        }
//        script = "/bin/echo '"+ protoText + resultEdit + "' | /usr/bin/pbcopy";
        script = "/usr/bin/osascript -e 'set the clipboard to \"" + protoText + resultString + "\"'";
        widget.system(script, null);
    	setTimeout("printText(resultString,false)",1000);  
        waiting = false;
        }
    else {
        printText("please wait...",false);
        waiting = true;
        }
    }
      }


//get IP
function getIpTime () {


    
        	var now = new Date().getTime();
    	var past = time + pause;
		if (widget.preferenceForKey(interfaceKey) != "wan" || now > past) {	
		    getip();
        }
}

function getip () {



    error = false;
    results = 0;
    resultString = 0;
    document.getElementById("refresh").src = "refresh_an.gif";
    busy = true;
    if  (widget.preferenceForKey(interfaceKey) == "wan" || !widget.preferenceForKey(interfaceKey))
    {
    	externalIp();
    	time = new Date().getTime();
	}
    else {
        internalIp(widget.preferenceForKey(interfaceKey));
        time = 1;
    }
    
 // icon
     if (widget.preferenceForKey(interfaceKey) == "wan" || !widget.preferenceForKey(interfaceKey)) {
         src = "url(External.png)";
        }
    else if (widget.preferenceForKey(interfaceKey) == "fw0") {
        src = "url(Firewire.png)";
        }
    else if (/(en)/g.test(widget.preferenceForKey(interfaceKey)) == true) {
	     if  (widget.preferenceForKey(widget.identifier + "-" + widget.preferenceForKey(interfaceKey)) == "Airport") {
			src = "url(Airport.png)"; 
			}
	   else if (widget.preferenceForKey(widget.identifier + "-" + widget.preferenceForKey(interfaceKey)) == "Ethernet") {
			src = "url(Ethernet.png)"; 
			}
        }
    else {
        src = "url(Ethernet.png)"; 
        }
          
     	document.getElementById('icon').style.backgroundImage = src;

}

//handle internal IP

function internalIp(interString){
if(window.widget) {
    var interString = widget.preferenceForKey(interfaceKey);
    script = "/sbin/ifconfig " + interString + " | /usr/bin/grep broadcast";
 //   script = "more '/ifconfig" + interString.charAt(2) +"' | /usr/bin/grep broadcast";
    results = widget.system(script, null).outputString;
    if (results) {
    resultArray = results.split("\n");
    resultString = resultArray[interfaceNo].match(/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/);
 //    resultString = results.replace(/\s/, "");
    printText (resultString, false);
    }
    else {
        errorText = interString + ": No Connection";
        printText (errorText, true);
        error = true;
                }    
    setTimeout("stopAnim()",600);            
    busy = false;
    if (waiting) {  
        copy();
        }
}
}

//handle external IP 

function externalIp () {

results = widget.system("/usr/bin/curl -q -m 15 -s " + url, externalIp2);
}

function externalIp2 (results) {
    if (results.outputString) {
		resultString = results.outputString.match(/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/);
        if (resultString) {
        	printText (resultString,false);
        	busy = false;
        	if (waiting) {  
            	copy();
            	}
        	 setTimeout("stopAnim()",300);
        	}
        else {
        	  printText ("Error 2! using Mirror", true);
              results = widget.system("/usr/bin/curl -q -m 15 -s " + url2nd, externalIp3);
        	}	
        }
    else { 
        printText ("Error 1! using Mirror", true);
        results = widget.system("/usr/bin/curl -q -m 15 -s " + url2nd, externalIp3);
        }
}

function externalIp3 (results) {
    if (results.outputString) {
        resultString = results.outputString.match(/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/);
        printText (resultString,false);
        busy = false;
        if (waiting) {  
            copy();
            }
        }
    else { 
        printText ("WAN: No connection", true);
        error = true;
        }
    setTimeout("stopAnim()",100);
}


function printText (text,small) {
if (small) {
    document.getElementById("Text").style.paddingTop = '2px';
    document.getElementById("ipnumber").style.font = 'normal 12px "Lucida Grande"';
}
else if (!small) {
    document.getElementById("Text").style.paddingTop = '0px';
    document.getElementById("ipnumber").style.font = 'bold 14px "Lucida Grande"';
}
if (!text) {
    text = "Error 3!(No Text)"
    }
document.getElementById("ipnumber").innerText = text;
}

function stopAnim() {
    document.getElementById("refresh").src = "refresh.gif";  
    }



function setup() {
	loadEnX();
	createGenericButton(document.getElementById('done'), 'Done', clickDone);
	if (!widget.preferenceForKey(interfaceKey)) {
		if (defaultPort = widget.preferenceForKey("defaultPort")) {
			widget.setPreferenceForKey(defaultPort,interfaceKey);
		}
		else {
	   		widget.setPreferenceForKey("wan",interfaceKey);
		}
	}
	
}

function clickDone () {
    hidePrefs ()
    mouseexit (event)
}

//  Dashboard Code from Apple Computer Inc.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");
       
	front.style.display="none";
	back.style.display="block";
	exitflip(event);

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");
      
	back.style.display="none";
	front.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
		

}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 // icon - no Apple code
 	document.getElementById('icon').style.display = 'none';
 // icon	
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

        var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;

	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
// icon - no Apple code
    if (!flipShown)
	    { 
		 	document.getElementById('icon').style.display = 'block';
        }
// icon        
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}